package at.ac.uibk.gitsearch.service.dto;

import java.io.Serializable;
import java.time.LocalDate;
import java.util.Objects;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

/**
 * A DTO for the {@link at.ac.uibk.gitsearch.domain.Likes} entity.
 */
public class LikesDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;

    @NotNull
    private LocalDate date;

    @NotNull
    private Integer userID;

    @Size(max = 255)
    private String exerciseID;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public LocalDate getDate() {
        return date;
    }

    public void setDate(LocalDate date) {
        this.date = date;
    }

    public Integer getUserID() {
        return userID;
    }

    public void setUserID(Integer userID) {
        this.userID = userID;
    }

    public String getExerciseID() {
        return exerciseID;
    }

    public void setExerciseID(String exerciseID) {
        this.exerciseID = exerciseID;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof LikesDTO)) {
            return false;
        }

        if (this.id == null) {
            return false;
        }
        LikesDTO likesDTO = (LikesDTO) o;
        return Objects.equals(this.id, likesDTO.id);
    }

    @Override
    public int hashCode() {
        return Objects.hash(this.id);
    }

    // prettier-ignore
    @Override
    public String toString() {
        return "LikesDTO{" +
            "id=" + getId() +
            ", date='" + getDate() + "'" +
            ", userID=" + getUserID() +
            ", exerciseID='" + getExerciseID() + "'" +
            "}";
    }
}
