import { ComponentFixture, TestBed } from '@angular/core/testing';
import { HttpClientTestingModule } from '@angular/common/http/testing';
import { HttpClientModule } from '@angular/common/http';
import { PeerReviewingComponent } from './peer-reviewing.component';
import { TranslateModule } from '@ngx-translate/core';
import { LocalStorageService, SessionStorageService } from 'ngx-webstorage';
import { RouterTestingModule } from '@angular/router/testing';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { FontAwesomeModule } from '@fortawesome/angular-fontawesome';
import { MultiSelectDropdownExerciseComponent } from 'app/admin/review-management/multi-select-dropdown-exercise/multi-select-dropdown-exercise.component';
import { ExerciseDetailsModalComponent } from 'app/exercise/exercise-details/exercise-details.component';
import { FilterPipe } from 'app/admin/review-management/filter.pipe';
import { faPlus } from '@fortawesome/free-solid-svg-icons';
import { FaIconLibrary } from '@fortawesome/angular-fontawesome';
import { of } from 'rxjs';
import { UserService } from 'app/entities/user/user.service';

describe('PeerReviewingComponent', () => {
  let component: PeerReviewingComponent;
  let fixture: ComponentFixture<PeerReviewingComponent>;
  const userServiceSpy = { getUser: jest.fn() };

  userServiceSpy.getUser.mockReturnValue(of({ email: 'test@example.com' }));

  beforeEach(async () => {
    await TestBed.configureTestingModule({
      imports: [
        HttpClientTestingModule,
        HttpClientModule,
        TranslateModule.forRoot(),
        RouterTestingModule,
        ReactiveFormsModule,
        FormsModule,
        FontAwesomeModule,
      ],
      declarations: [PeerReviewingComponent, ExerciseDetailsModalComponent, MultiSelectDropdownExerciseComponent, FilterPipe],
      providers: [LocalStorageService, SessionStorageService, { provide: UserService, useValue: userServiceSpy }],
    }).compileComponents();
  });
  beforeEach(() => {
    const iconLibrary: FaIconLibrary = TestBed.inject(FaIconLibrary);
    // add the faPlus icon to the library
    iconLibrary.addIcons(faPlus);

    fixture = TestBed.createComponent(PeerReviewingComponent);
    component = fixture.componentInstance;
    component.ngOnInit(); // manually triggering ngOnInit
    fixture.detectChanges();
  });

  it('should create', () => {
    expect(component).toBeTruthy();
  });
});
