package at.ac.uibk.gitsearch.service.mapper;

import static org.assertj.core.api.Assertions.assertThat;

import at.ac.uibk.gitsearch.IntegrationTest;
import at.ac.uibk.gitsearch.domain.ReviewRating;
import at.ac.uibk.gitsearch.domain.enumeration.ReviewStatus;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;

@IntegrationTest
class ReviewRatingMapperIT {

    @Autowired
    private ReviewRatingMapper reviewRatingMapper;

    @Test
    void testReviewRatingMapper() {
        ReviewRating rr = new ReviewRating().status(ReviewStatus.REVIEW_IMPROVED);
        ReviewRating rrMapped = reviewRatingMapper.toEntity(reviewRatingMapper.toDto(rr));

        assertThat(rrMapped.getStatus()).isEqualTo(ReviewStatus.REVIEW_IMPROVED);
    }
}
